/*  ************** ALARMINO v1.0 *********************
 *  ------------- 
 *  
 *   Autor: mpuenter
 *   
 *   Millores respecte la versio 0.3:
 *   
 *   - Control del menú per comandament IR (DSR-0112)
 *   - Obté la contrasenya de la EEPROM i la compara amb l'entrada per l'usuari
 *   - Nova opcio 4 del menú (4. Canvi de clau). Guarda la nova contrasenya a la EEPROM
 *   - deixar entrar la contrasenya només 3 cops, a l'entrada i al canvi de clau
 *   - Afegir sensors IR   
 *   
 *   BUGS:
 *   
 *   - Si entro la contraseña y, antes de aceptar, cambio el cursor de pocicion no acepta la pass correcta.
 *   - si se cambia la pass y se deja la nueva en blanco, graba como pass 0,' ',' '. No permitir dejar nada en blanco.
 *   
 *   Propostes de millora:
 *   
 *   - S'indica al menú quina opcio està activa amb un asterisc parpadejant   
 *   
 *****************************************************/
 
// Inici declaració variables i llibreries 'void initContrasenyaEEPROM()' i 'void updateContrasenya()'
#include <EEPROM.h>
// Fi declaració variables i llibreries 'void initContrasenyaEEPROM()' i 'void updateContrasenya()'

// Inici declaració variables i llibreries 'void i2cClient()'
// Aquest codi forma part de la comunicació amb el servidor GPRS
//#include <Wire.h>
// Aquest codi forma part de la comunicació amb el servidor GPRS
// Fi declaració variables i llibreries 'void i2cClient()'

// Inici declaració variables i llibreries control menús LCD
#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

const int numeroDeMenus = 1;
const int numeroMaximoDeSubmenus = 4;

char tituloMenu[numeroDeMenus][17] = {"<Modes Alarmino>"};

byte numeroDeSubmenus[numeroDeMenus] = {4};

char tituloSubmenu[numeroDeMenus][numeroMaximoDeSubmenus][17] =
{
  "1. Alarmino OUT","2. Alarmino IN","3. Desactivar","4. Canvi clau"};

int adc_key_val[5] = {
  50, 200, 400, 600, 800 };
int NUM_KEYS = 5;
int adc_key_in;
int key = -1;
int oldkey = -1;
boolean luzEncendida = true;
unsigned long time;
int x = 0;
int y = 0;
bool alarmaIN = false;
bool alarmaOUT = false;
bool canviCLAU1 = false;      // Control opcio '4. Canvi clau'
bool canviCLAU2 = false;      // Control opcio '4. Canvi clau'
int intentsCLAU = false;      // Número d'intents per a entrar la contrasenya
int control1 = false;         // control contrasenya inicial
#define pinLedAlarmaIN 30
#define pinLedAlarmaOUT 31
// Fi declaració variables i llibreries control menús LCD

// Inici declaració variables 'void pantallaContrasenya()'
int z = 7;
char caracterActual = '0';
char passwordAcces[3]; // Es la contraseña de l'aplicació i es llegeix de la EEPROM
char passwordIntro[3];
bool usuariAcceptat = false;
byte tempsEspera; // temps d'espera per que s'activi l'alarma total (Mode '1.1 Alarmino OUT')
// Fi declaración variables 'void pantallaContrasenya()'



// Inici declaració variables 'void introStarWars()' (Rutina musical)
#define pinPiezo A7     // pin A7 analógic del piezoeléctric  
#define  f4    2865    // 349 Hz 
#define  a4s   2146
#define  f5    1433    // 698 Hz
#define  a4    2272    // 440 Hz 
#define  c5    1912    // 523 Hz
#define  R     0       // Define a special note, 'R', to represent a rest

// MELODIES and TIMING //
//  melody[] is an array of notes, accompanied by beats[],
//  which sets each note's relative length (higher #, longer note)

// Melody 1: Star Wars Theme
int melody1[] = {  f4,  f4, f4,  a4s,   f5};
int beats1[]  = {  21,  21, 21,  128,  128};

// Melody 2: Star Wars Theme (al revés para password erroneo)
int melody2[] = {  f5,  a4s, f4,  f4,   f4};
int beats2[]  = {  128,  128, 21,  21,  21};
byte melodia; // determina si sona melody1 (amb beats1) o melody2 (amb beats2)
int MAX_COUNT = sizeof(melody1) / 2; // Melody length, for looping.
long tempo = 10000; // Set overall tempo
int pause = 1000; // Set length of pause between notes
int rest_count = 50; // Loop variable to increase Rest length (BLETCHEROUS HACK; See NOTES)

// Initialize core variables
int toneM = 0;
int beat = 0;
long duration  = 0;
// Fin declaracion variables 'void introStarWars()' (Rutina musical)

// Inici declaració variables i llibreries 'void mandoIR()' // Rutina per mando IR
#include <IRremote.h>
int RECV_PIN = 48;
IRrecv irrecv(RECV_PIN);
decode_results mandoIR;
int keyIR = -1;
int oldkeyIR = -1;
// Fi declaració variables i llibreries 'void mandoIR()' // Rutina per mando IR

// Inici declaració variables i llibreries 'void control()'

//------------------------------------------------------------------
// Inici definicions llibreries control de temps
#include <TimeLib.h>
#include <Wire.h>
#include <DS1307RTC.h>
// Fi definicions llibreries control de temps
//------------------------------------------------------------------
// Inici definicions variables control de temps
tmElements_t tm; // LIbreria Time.h
const char* relojActivo;
bool parse = false;
bool config = false;
boolean horaRetrasada;
long unsigned int epoch = 0;
byte minutoMemory      = 0;
byte periferic         = 0;
byte menuActivo        = 0;
byte submenuActivo     = 0;
int  esperaTimeOut     = 100;

// Fi definicions variables control de temps
//------------------------------------------------------------------
// Inici definicions Llibreries i asignacions RadioFrecuencia
#include <nRF24L01.h>
#include <RF24.h>
#include <RF24_config.h>
#include <SPI.h>

#define pinCE 49             // Pin entrada CE 
#define pinCSN 53           // pin sortida CSN
RF24 radio(pinCE, pinCSN);

// Radio pipes per escoltar  i emitir respectivament
const uint64_t pipes[2] = { 0xF0F0F0F0E1LL, 0xF0F0F0F0D2LL };
// Fi definicions Llibreries i asignacions RadioFrecuencia
//------------------------------------------------------------------
// Inici definicions estructures de dades RadioFrecuencia

// Estructura de dades per a comunicar per RF entre Arduinos
// Recomenat tamany <= 32 Bytes
struct DATOS
{
  byte cap;            // Marca inicio = 123   // Longitud 1 byte acumulada =  1 Byte
  byte sensor;         // Codi numeric sensor  // Longitud 1 byte acumulada =  2 Byte
  // 1 - sensor de clima      DTH11
  // 2 - sensor d'aigua       FC-37
  // 3 - sensor d'infrarojos  L-IR
  // 4 - sensor d'Ultrasons   HC-SR04
  // 5 - sensor de Moviment   HC-SR501
  // 6 - detector tallCorrent Transformador + alimentador adaptat al efecte
  // 0 - aquest valor indica que es tracta d'un registre de sincronisme
  //     de data i hora que ve informat al camp 'epoch'
  byte serie;          // Nº sequencia sensor   // Longitud 1 byte acumulada = 3 Byte
  int valor1;          // Sensor temperatura    // Longitud 4 byte acumulada = 7 Byte
  int valor2;          // Sensor infrarojos    // Longitud 4 byte acumulada = 11 Byte
  float valor3;        // Sensor moviment     // Longitud 4 byte acumulada = 15 Byte
  int valor4;          // Sensor ultrasons    // Longitud 2 byte acumulada = 17 Byte
  byte valor5;         // Sensor de corrent    // Longitud 1 byte acumulada = 18 Byte
  byte interrupcio;    // Flag Polling  = 111   // Longitud 1 byte acumulada = 19 Byte
                       // Flag Interrup = 222
  byte alarma;         // Codi d'alarma         // Longitud 1 byte acumulada = 20 Byte
  unsigned long epoch; // Hora UNIX             // Longitud 4 byte acumulada = 24 Byte
  byte periferic;      // Arduino que contesta  // Longitud 1 byte acumulada = 25 Byte
  byte menuActivo;     // Menu seleccionado     // Longitud 1 byte acumulada = 26 Byte
  byte submenuActivo;  // submenu seleccionado  // Longitud 1 byte acumulada = 27 Byte
  byte reservado1;     // Reservado futuro uso  // Longitud 1 byte acumulada = 28 Byte
  byte reservado2;     // Reservado futuro uso  // Longitud 1 byte acumulada = 29 Byte
  byte cua;            // Marca final = 234     // Longitud 1 byte acumulada = 30 Byte
};
union REDATOS {        // Redefinicion de la estructura DATOS
  DATOS dato;
  byte  b[sizeof(DATOS)];
}
MIS_DATOS, TUS_DATOS; // Dues areas independients iguals per a emitir i rebre dades
// Fi definicions estructures de dades RadioFrecuencia

//------------------------------------------------------------------

////////////////////////////////////////////////////////////////////
// campos para DEBUG hasta que esten todos los tiempos calibrados
unsigned long inicio;    // solo para DEBUG
unsigned long esperado;  // solo para DEBUG
unsigned long total = 0; // solo para DEBUG
////////////////////////////////////////////////////////////////////

// Fi declaració variables i llibreries 'void control()'
//---------------------------------------------------------------------

// Conexions per les interrupcions basades en events
//
// PLACA         |PIN Digital asociado a cada Tipo de interrupción|
// ARDUINO       | INT 0 | INT 1 | INT 2 | INT 3 | INT 4 | INT 5  |
//----------------------------------------------------------------|
// ARDUINO MEGA  | PIN 2 | PIN 3 | PIN 21| PIN 20| PIN 19| PIN 18 |
// ARDUINO UNO   | PIN 2 | PIN 3 |   -   |   -   |   -   |   -    |
// ARDUINO NANO  | PIN 2 | PIN 3 |   -   |   -   |   -   |   -    |
//----------------------------------------------------------------|


void setup()
{
  // MPR 02/09/15
  Serial.begin(115200);
  // MPR 02/09/15
  pinMode (pinPiezo, OUTPUT); 
  
  lcd.begin(16, 2);

  irrecv.enableIRIn(); // Inicia el receptor IR per al comandament a distancia

  getContrasenyaEEPROM(); // Mou la contraseña de la EEPROM a la variable de treball passwordIntro[]
    
  pantallaContrasenya();
  control1 = true;
  memset(passwordIntro, ' ', sizeof(passwordIntro)); // Reseteja la variable array de la contrasenya  
  usuariAcceptat = false;

  introAlarmino();  

// Inici setUp gestion de hora
  relojActivo = "Ninguno";

  // En principio vamos a trabajar sin RTC
  // Comentamos ponerEnHora() y activamos ponerEnHoraArduino()
  // Caso de trabajar con un reloj RTC
  // comentariamos ponerEnHoraArduino(); y activariamos ponerEnHora();

  // ponerEnHora();                  // Comentado. Sin reloj RTC
  ponerEnHoraArduino();
  // Fi setUp gestion de hora
  //----------------------------------
  // Inici SetUp RadioFrecuencia
  // pinMode(pinCSN, OUTPUT);

  // Setup i configuració RF NRF24L01
  radio.begin();
  radio.setRetries(15, 15);           // esperas entre reintentos
  radio.setPayloadSize(32);           // Tamany del lot  que sembla mes convenient
  radio.setChannel(106);              // De 0 a 127
  radio.setDataRate(RF24_250KBPS);    // reducir ancho de banda

  // radio.setPALevel(RF24_PA_MIN);   // PA Level minimo
  // radio.setPALevel(RF24_PA_LOW);   // PA Level bajo
  radio.setPALevel(RF24_PA_HIGH);     // PA Level alto
  // radio.setPALevel(RF24_PA_MAX);   // PA Level maximo (defecto)

  // Engegar la radio

  // Nosaltres emitirem pel primer pipe que es el que escolta la periferia
  // Periferia emiteix pel segon pipe i nosaltres lo escoltem

  radio.openWritingPipe(pipes[0]);    // Obrir pipe de sortida
  radio.openReadingPipe(1, pipes[1]); // Obrir pipe de entrada
  radio.startListening();             // començem escoltant
  // Fi SetUp RadioFrecuencia
  //----------------------------------
  registroSincronia(); // Enviem primer de tot un registre de sincronia
  // Que fara que tots els periferics es posin en hora
}

void loop()
{

  //control();
  
  if (alarmaIN == true or alarmaOUT == true) {
    control();
/*
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
//////////////////////////////////////
//getClima();
//getInundacio();
//getIR();
//////////////////////////////////////
* Aqui se llamaban a las rutinas de temp, humedad i Infrarojos en la version antigua para 'preguntar' al sensor (son las tres lineas de codigo precedentes comentadas //)
* Hay que tener en cuenta que en este punto, el menú controla si uno de los dos modos de alarma está activo, por lo tanto aqui se inicializan 
* los sensores comunes a los dos modos. Los sensores que se deberán activar en este punto deben ser los mismos, es decir: TEMERATURA, HUMEDAD Y INFRAROJOS
* 
* 
* 
* 
* ENTONCES ES AQUI, AL PRINCIPIO DEL LOOP Y EN ESTE PUNTO DONDE SE DEBERÁ ENVIAR LA SEÑAL DE ACTIVOS A LOS SENSORES TEMERATURA, HUMEDAD Y INFRAROJOS
* 
* Aqui se debera 'hablar' con los sensores que trabajan sin interrupcion
* 
* 
* 
*/
  }
  if (alarmaOUT == true) {
/*
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 *
//getUltrasons();
//////////////////////////////////////
* Aqui se llamaba a la rutina de Ultrasonidos en la version antigua para 'preguntar' al sensor (es la linea de codigo precedente comentada //)
* Hay que tener en cuenta que en este punto, el menú controla si un modo de los dos posibles está activo, por lo tanto aqui se inicializa 
* el sensor de ULTRASONIDOS.
* 
* 
* 
* 
* ENTONCES ES AQUI, AL PRINCIPIO DEL LOOP Y EN ESTE PUNTO DONDE SE DEBERÁ ENVIAR LA SEÑAL DE ACTIVO AL SENSOR DE ULTRASONIDOS
* 
* Aqui se debera 'hablar' con los sensores que trabajan sin interrupcion
* 
* 
* 
* 
*/
  }
  // Si han pasado mas de 10 segundos apagamos la luz
  if (millis() - time > 10000) {
    pinMode(10, OUTPUT);
    digitalWrite(10, LOW);
    luzEncendida = false;
  }

  lcd.noBlink(); // Hace desaparecer el cursor parpadeante

  adc_key_in = analogRead(0);    // Leemos el valor de la pulsacion
  key = get_key(adc_key_in);     // Obtenemos el boton pulsado

  keyIR = -1;
  keyIR = getMandoIR();          // Leemos y Obtenemos el valor de la pulsacion del mando IR
  
  if (key != oldkey or keyIR != oldkeyIR)   // if keypress is detected
  {
    espera(50);   
    adc_key_in = analogRead(0);    // Leemos el valor de la pulsacion
    key = get_key(adc_key_in);     // Obtenemos el boton pulsado

    keyIR = -1;;
    keyIR = getMandoIR();         // Leemos y Obtenemos el valor de la pulsacion del mando IR
    
    if (key != oldkey or keyIR != oldkeyIR)
    {

      time = millis();
      if (!luzEncendida) {  // Al pulsar cualquier tecla encendemos la pantalla
        pinMode(10, INPUT);
        luzEncendida = true;
      }
      else {  // si la pantalla esta encendida seguimos funcionando normalmente
        
        oldkey = key;
        oldkeyIR = keyIR;
                
        if (key == 0 or keyIR == 3927) { // Se ha pulsado la tecla derecha
          x++;
          if (x > numeroDeMenus - 1) x = numeroDeMenus - 1;
          y = 0;
        }
        if (key == 1 or keyIR == 3924) {  // Se ha pulsado la tecla arriba
          y++;
          if (y > numeroDeSubmenus[x] - 1) y = numeroDeSubmenus[x] - 1;
        }
        if (key == 2 or keyIR == 3925) {  // Se ha pulsado la tecla abajo
          y--;
          if (y < 0) y = 0;
        }
        if (key == 3 or keyIR == 3926) {  // Se ha pulsado la tecla izquierda
          x--;
          if (x < 0) x = 0;
          y = 0;
        }
        if (key == 4 or keyIR == 3941) { // Se ha pulsado la tecla de seleccion
          
          if (x == 0) {        // menu Modes Alarmino
            
          switch (y) {
            
            case 0:         // opcio 1. Alarmino OUT 
              
              //Aquí s'activa la opció 1. Alarmino OUT
              digitalWrite(pinLedAlarmaIN, HIGH);
              digitalWrite(pinLedAlarmaOUT, HIGH);
              alarmaOUT = true;
              
              alarmaIN = false;
 
              tempsEspera = 5;
              while (tempsEspera > 0){    //Aquí s'activa el temps d'espera de la la opció 1,1 Alarmino OUT
                lcd.clear();
                lcd.print("  Alarmino OUT  ");
                lcd.setCursor(0, 1);
                lcd.print("activacio en ");
                lcd.setCursor(13,1);
                lcd.print(tempsEspera);
                lcd.print("s");
                espera(1000);
                tempsEspera--;
              }
/*
 * 
 * 
 *              ANTIGUAS LLAMADAS A LAS INTERRUPCIONES op.ALARMINO OUT(lAS INTERRUPCIONES 0, 1, 2 Y 3 SON FALSAS INTERRUPCIONES, OLVIDATE DE ELLAS EN ESTE PUNTO)
 * 
 * 
 * 
 * 
 *
//              attachInterrupt(0, intInundacio, CHANGE); // La detecció d'inundacio ('void getInundacio') funciona sense interrupcio, la seva funcio interrupcion la supleix la rutina 'void intInundacio()'
//              attachInterrupt(1, intIR, RISING);        // executa el loop 'void getIR'              
//              attachInterrupt(2, intClima, CHANGE);     // El clima ('void getClima') funciona sense interrupcio, la seva funcio interrupcion la supleix la rutina 'void intClima()'
//              attachInterrupt(3, intUltrasons, RISING); // Els ultrasons ('void getUltrasons') funcionen sense interrupcio, la seva funcio interrupcion la supleix la rutina 'void intUltrasons()
//              attachInterrupt(4, getMoviment, CHANGE);  // executa al loop 'void getMoviment'
//              attachInterrupt(5, getVolts, FALLING);    // executa al loop 'void getVolts'
 * 
 * 
 * 
 * 
*/              
              lcd.setCursor(0, 1);
              lcd.print("    activat     ");
              espera(1000);
              break;
              
            case 1:         // opcio 2. Alarmino IN
            
              //Aquí s'activa la opció 2. Alarmino IN (es desactiven alguns sensors)
              digitalWrite(pinLedAlarmaOUT, LOW);
              digitalWrite(pinLedAlarmaIN, HIGH);              
              alarmaOUT = false;
              alarmaIN = true;
/*
 * 
 * 
 *              ANTIGUAS LLAMADAS A LAS INTERRUPCIONES op.ALARMINO OUT(lAS INTERRUPCIONES 0, 1, 2 Y 3 SON FALSAS INTERRUPCIONES, OLVIDATE DE ELLAS EN ESTE PUNTO)
 * 
 * 
 * 
 * 
 *                            
//              attachInterrupt(0, intInundacio, CHANGE); // La detecció d'inundacio ('void getInundacio') funciona sense interrupcio, la seva funcio interrupcion la supleix la rutina 'void intInundacio()'
//              attachInterrupt(1, intIR, RISING);        // executa el loop 'void getIR'
//              attachInterrupt(2, intClima, CHANGE);     // El clima ('void getClima') funciona sense interrupcio, la seva funcio interrupcion la supleix la rutina 'void intClima()'
//              detachInterrupt(3);
//              digitalWrite(pinLedUltrasons, LOW);
//              attachInterrupt(4, getMoviment, CHANGE);  // executa al loop 'void getMoviment'
//              detachInterrupt(5);
* 
* 
* 
* 
*/ 
              lcd.clear();
              lcd.print("  Alarmino IN   ");
              lcd.setCursor(0, 1);
              lcd.print("    activat     ");
              espera(1000);
              break;
              
            case 2:         // opcio 3. Desactivar
              
              //Aquí s'activa la opció 3. Desactivar (es desactiva tot el sistema)           
              if (alarmaIN == true or alarmaOUT == true) { // Només demanarà la contrasenya per desactivar si hi ha algún mode activat prèviament
                
                pantallaContrasenya();
                memset(passwordIntro, ' ', sizeof(passwordIntro)); // Reseteja la variable array de la contrasenya
                usuariAcceptat = false;

                if (intentsCLAU != 3) {                
                
                digitalWrite(pinLedAlarmaIN, LOW);
                digitalWrite(pinLedAlarmaOUT, LOW);
                               
                alarmaOUT = false;
                alarmaIN = false;
 /*
 * 
 * 
 *              ANTIGUAS LLAMADAS A LAS INTERRUPCIONES op.ALARMINO OUT(lAS INTERRUPCIONES 0, 1, 2 Y 3 SON FALSAS INTERRUPCIONES, OLVIDATE DE ELLAS EN ESTE PUNTO)
 * 
 * 
 * 
 * 
 *               
//                detachInterrupt(0);
//                digitalWrite(pinLedAigua, LOW);
//                detachInterrupt(1);
//                digitalWrite(pinLedIR, LOW);
//                detachInterrupt(2);
//                digitalWrite(pinLedClima, LOW);
//                detachInterrupt(3);
//                digitalWrite(pinLedUltrasons, LOW);
//                detachInterrupt(4);
//                digitalWrite(pinLedMoviment, LOW);
* 
* 
* 
* 
*/ 
                //lcd.setCursor(0, 0);
                lcd.clear();
                lcd.print("  Alarmino v1.0 ");
                lcd.setCursor(0, 1);
                lcd.print("   desactivat   ");  
                espera(1000);
                }
                intentsCLAU = 0;   
              }
              break;

            case 3:         // opcio 4. Canvi clau
              
              canviCLAU1 = true;                    
              pantallaContrasenya();    // Demana clau antiga      
              memset(passwordIntro, ' ', sizeof(passwordIntro)); // Reseteja la variable array de la contrasenya                      
              usuariAcceptat = false;           
              canviCLAU1 = false;

              if (intentsCLAU != 3) {  
                canviCLAU2 = true;              
                pantallaContrasenya();    // Demana clau nova              
                memset(passwordIntro, ' ', sizeof(passwordIntro)); // Reseteja la variable array de la contrasenya
                usuariAcceptat = false;
                canviCLAU2 = false;
              }
              intentsCLAU = 0;  
              break;              
            }             
          }
        }
        lcd.clear();
        lcd.print(tituloMenu[x]);
        lcd.setCursor(0, 1);
        lcd.print(tituloSubmenu[x][y]);
      }
    }
  }
  espera(50); 
}

// Convertimos el valor leido en analogico en un numero de boton pulsado
int get_key(unsigned int input)
{
  int k;

  for (k = 0; k < NUM_KEYS; k++)
  {
    if (input < adc_key_val[k])
    {
      return k;
    }
  }

  if (k >= NUM_KEYS)k = -1;  // Error en la lectura
  return k;
}

/*******************************************************************
* RUTINA:      pantallaContrasenya
* DESCRIPCIO:  Pantalla que controla l'entrada per LCD de la conrasenya de l'alarma.
*******************************************************************/

void pantallaContrasenya()
{                 
  if (alarmaIN == false && alarmaOUT == false && canviCLAU1 == false && canviCLAU2 == false) {
    lcd.clear();
    //lcd.setCursor(0, 0);
    lcd.print("  Alarmino v1.0 ");
    espera(1500);
  }

  lcd.clear();
  lcd.print(" Clau seguretat ");
    
  if (canviCLAU1 == true) {
    lcd.clear();
    lcd.print("  Clau antiga   ");
  }
  else if (canviCLAU2 == true) {
    lcd.clear();
    lcd.print("   Clau nova    ");    
  }
  lcd.setCursor(0, 1);
  lcd.print("------>   <-----");
  lcd.setCursor(7, 1);            // posicion inicial para entrar la clave
  lcd.blink();                    // Muestra el cursor parpadeando
  pinMode(10, OUTPUT);
  digitalWrite(10, HIGH);
  caracterActual = '0';
  
  while (!(passwordIntro[0] == passwordAcces[0] && passwordIntro[1] && passwordAcces[1] && passwordIntro[2] != passwordAcces[2])
        or (usuariAcceptat == false))
  {
    if (alarmaIN == true or alarmaOUT == true) {
      
/*
 * 
 * 
 * 
// ************************************ Inici **********************************************************  VERSIO ANTIGA
// Es tornen a invocar els voids getClima, getInundacio i getUltrasons (que no s'activen per interrupcio) 
// perqué no s'aturin mentre estem a la pantalla de contrasenya, la resta de sensors també segueixen 
// actius per interrupcio mentre no s'introdueixi el password correcte.   
//
//      getClima();
//      getInundacio();
//    }
//    if (alarmaOUT == true) {
//      getUltrasons();
//    }
// ************************************ Fi *************************************************************  VERSIO ANTIGA
*
*
*
*/
    }
    if (usuariAcceptat == true) return;
    
    adc_key_in = analogRead(0);    // Leemos el valor de la pulsacion
    key = get_key(adc_key_in);    // Obtenemos el boton pulsado

    keyIR = -1;
    keyIR = getMandoIR();         // Leemos y Obtenemos el valor de la pulsacion del mando IR
    
    if (key != oldkey or keyIR != oldkeyIR)   // if keypress is detected
    {
      espera(50);       

      adc_key_in = analogRead(0);    // Leemos el valor de la pulsacion
      key = get_key(adc_key_in);    // Obtenemos el boton pulsado

      keyIR = -1;
      keyIR = getMandoIR();         // Leemos y Obtenemos el valor de la pulsacion del mando IR
            
      if (key != oldkey  or keyIR != oldkeyIR)
      {
        oldkey = key;
        oldkeyIR = keyIR;
        
        if (key == 0 or keyIR == 3927) { // Se ha pulsado la tecla derecha
          z++;
          if (z == 7) caracterActual = passwordIntro[0];
          else if (z == 8) caracterActual = passwordIntro[1];
          else if (z == 9) caracterActual = passwordIntro[2];
          if (z < 7) z = 7;
          if (z > 9) z = 9;
          caracterActual='0';
          
          if (keyIR > 3903 && keyIR < 3914) { // Tratamiento parea el mando a distancia
              keyIRtoNum(); // Informa la variable caracter actual con el valor del numero pulsado con el mando a distancia
          }          
        }
        if (key == 1) {  // Se ha pulsado la tecla arriba
          caracterActual++;
          if (caracterActual > '9') caracterActual = '9';
          
          if (keyIR > 3903 && keyIR < 3914) { // Tratamiento parea el mando a distancia
            keyIRtoNum(); // Informa la variable caracter actual con el valor del numero pulsado con el mando a distancia
          }           
          lcd.write(caracterActual);
        }
        if (key == 2 or keyIR == 3925) {  // Se ha pulsado la tecla abajo
          caracterActual--;
          if (caracterActual < '0') caracterActual = '0';
          lcd.write(caracterActual);
        }
        if (key == 3 or keyIR == 3926) {  // Se ha pulsado la tecla izquierda
          z--;
          if (z == 7) caracterActual = passwordIntro[0];
          else if (z == 8) caracterActual = passwordIntro[1];
          else if (z == 9) caracterActual = passwordIntro[2];
          if (z < 7) z = 7;
          caracterActual='0';
        }
        if (key == 4 or keyIR == 3941) // Se ha pulsado la tecla de seleccion
        {
          if (canviCLAU2 == true) {
            updateContrasenyaEEPROM();  // AQUI SE GRABA LA NUEVA PASS EN LA EEPROM 
            getContrasenyaEEPROM();     // se obtiene de nuevo la nueva pass para que la acepte la aplicación
            passwordIntro[0] = passwordAcces[0];
            passwordIntro[1] = passwordAcces[1];
            passwordIntro[2] = passwordAcces[2];          
            //memset(passwordIntro, 0, sizeof(passwordIntro)); // Resetea la variable array
          }
          // Comprovem que la password sigui la correcta comparant-la amb la existent a la EEPROM  
          if (passwordIntro[0] == passwordAcces[0] && passwordIntro[1] == passwordAcces[1] && passwordIntro[2] == passwordAcces[2]) {
            usuariAcceptat = true;            
            lcd.noBlink();
            lcd.clear();
            lcd.print("  Alarmino v1.0 ");
            lcd.setCursor(0, 1);
            if (canviCLAU1 == false && canviCLAU2 == false) {

                if (alarmaIN == false && alarmaOUT == false) {
                  lcd.print("   iniciant...  ");
                }
                else {
                  lcd.print(" desactivant... ");
                }
                melodia=1;
                playSong(melodia);

            }
            else  if (canviCLAU2 == true) {
              lcd.setCursor(0, 1);
              lcd.print(" Clau canviada! ");
              espera(2000);
            }
          }
          else
          {
            if (control1 == true) intentsCLAU++; // Sumem un intent fallit (máxim 3)
            //Serial.println(intentsCLAU);
            //Serial.println(control1);
            lcd.clear();
            lcd.print("  Alarmino v1.0 ");
            lcd.setCursor(0, 1);            
            lcd.print("   denegat...   ");
            melodia=2;
            playSong(melodia);
            if (intentsCLAU == 3) {                 
              return;
            }            
            lcd.setCursor(0, 0);              
            lcd.print(" Clau seguretat");
   
            if (canviCLAU1 == true) {
              lcd.clear();
              lcd.print("  Clau antiga   ");
            }
            else if (canviCLAU2 == true) {
              lcd.clear();
              lcd.print("   Clau nova    ");    
            }
            lcd.setCursor(0, 1);
            lcd.print("------>   <-----");
            lcd.setCursor(7, 1); // posicion inicial para entrar la clave
          }
          z = 7;
        }

        if (keyIR > 3903 && keyIR < 3914) { // Si introducen valores para la contraseña con mando IR
          keyIRtoNum(); // Informa la variable caracterActual con lo introducido por el mando IR
          lcd.write(caracterActual);
        }

        if (z == 7) passwordIntro[0] = caracterActual;
        else if (z == 8) passwordIntro[1] = caracterActual;
        else if (z == 9) passwordIntro[2] = caracterActual;
        lcd.setCursor(z, 1);
      }
    }
    espera(50); 
  }
}

/*******************************************************************
* RUTINA:      introAlarmino
* DESCRIPCIO:  Muestra pantalla d'inici de l'aplicació, acompanyada d'una breu sintonia
*              mitjançant un buzzer
*
* Pins de conexió:
* Arduino     Buzzer (piezo)
*   A9         Analog A9
*   3.3V         VCC
*   GND          GND
*******************************************************************/
void introAlarmino() {   
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(tituloMenu[x]);
  lcd.setCursor(0, 1);
  lcd.print(tituloSubmenu[x][y]);
  time = millis();  
}
void playSong(byte &m) {
  for (int i = 0; i < MAX_COUNT; i++) {
    if (m == 1) {
      toneM = melody1[i];
      beat = beats1[i];
    }
    else {
    if (m == 2) {
      toneM = melody2[i];
      beat = beats2[i];
    }
    }
    duration = beat * tempo; // Set up timing

    playTone(); // A pause between notes
    delayMicroseconds(pause);
  }
}

// PLAY TONE  //
// Pulse the speaker to play a tone for a particular duration
void playTone() {
  long elapsed_time = 0;
  if (toneM > 0) { // if this isn't a Rest beat, while the tone has
    //  played less long than 'duration', pulse speaker HIGH and LOW
    while (elapsed_time < duration) {

      digitalWrite(pinPiezo, HIGH);
      delayMicroseconds(toneM / 2);

      // DOWN
      digitalWrite(pinPiezo, LOW);
      delayMicroseconds(toneM / 2);

      // Keep track of how long we pulsed
      elapsed_time += (toneM);
    }
  }
  else { // Rest beat; loop times delay
    for (int j = 0; j < rest_count; j++) { // See NOTE on rest_count
      delayMicroseconds(duration);
    }
  }
}



/*******************************************************************
* RUTINA:      espera
* DESCRIPCIO:  Espera el número especificat de segons sense 'dormir' el Arduino
*              paràgraf permetre la programació per Interrupcions
*******************************************************************/
void espera(int t) {
  // Rutina per a substituir delays no desitjats per tal d'utilitzar Interrupcións                
  // Ha de tenir definit "int temps;"  
  // NOTA: No utilitzar dins del codigo d'una Interrupció                                                            
  t = t - ((t / 1000) * 1.7); // Compensacio per l'increment de temps observat sobre "delay();"                          
  int coci = t / 1000; // Numero de segons sencers
  int rest = t % 1000; // Milisegons restants   
  while (coci > 0) {
    unsigned long tempsini = millis();
    unsigned long tempsfin = tempsini;
    while ((tempsfin - tempsini) <=1000)  { // loop de 1000ms
      tempsfin = millis();
    }
    coci = coci - 1;
  }
  while (rest > 0) {
    delayMicroseconds(1000); // Espera Mil microsegons (un milisegon)) cada volta
    rest = rest - 1;            
  }  
}

/*******************************************************************
* MODULO:      getMandoIR
* DESCRIPCIO:  Decodifica les tecles del mando a distancia IR mitjançant 
*              el receptor IR VS1838B (pin 23)  i la llibrería IRrecv
*              
* CODIS TECLES MANDO A DISTANCIA
*  Arriba = F54
*  Abajo = F55
*  Izquierda = F56
*  Derecha = F57
*  Ok  = F65
*  Off = F7D
*  0 = F40
*  1 = F41
*  2 = F42
*  3 = F43
*  4 = F44
*  5 = F45
*  6 = F46
*  7 = F47
*  8 = F48
*  9 = F49
*  
*******************************************************************/
int getMandoIR() {
  if (irrecv.decode(&mandoIR)) {
    keyIR = mandoIR.value;
    irrecv.resume(); // Rep el seguent valor
  }
  return keyIR;
}

int keyIRtoNum() {
  getKeyIRtoNum(keyIR);
  return caracterActual;
}

void getKeyIRtoNum(int &gKeyIR) {
  switch (gKeyIR)
  {
    case 3904:
      caracterActual = '0';
      break;
    case 3905:
      caracterActual = '1';
      break;              
    case 3906:
      caracterActual = '2';
      break;
    case 3907:
      caracterActual = '3';
      break;
    case 3908:
      caracterActual = '4';
      break;
    case 3909:
      caracterActual = '5';
      break;
    case 3910:                                                                           
      caracterActual = '6';
      break;
    case 3911:
      caracterActual = '7';
      break;
    case 3912:
      caracterActual = '8';
      break;
    case 3913:                                                                           
      caracterActual = '9';
      break;                
  }
}

/*******************************************************************
* RUTINA:      getContrasenyaEEPROM
* DESCRIPCIO:  Llegeix la contrasenya de fábrica de tres nums (111)  de la EEPROM
*              i la mou a la variable de treball passwordAcces[3]
*******************************************************************/
void getContrasenyaEEPROM()
{  
  // Llegeix un byte de l'adreça actual
  for (int i = 0; i < 3; i++) {
    passwordAcces[i] = EEPROM.read(i);
  }
}

/*******************************************************************
* RUTINA:      updateContrasenyaEEPROM
* DESCRIPCIO:  Modifica la contrasenya de 3 numeros de la EEPROM
*******************************************************************/
void updateContrasenyaEEPROM()
{  
  for (int i = 0; i < 3; i++)  { // Grava la contrasenya '111' a les posicions 0 a 2 de la EEPROM
    EEPROM.write(i, passwordIntro[i]);
  }
}

/*******************************************************************
* RUTINA:      control
* DESCRIPCIO:  
*******************************************************************/
void control(void)
{
  // Quan canvia el minut s'executa la rutina de canvi d'hora estiu <-> ivern i de pas
  // enviem tambe un registre de sincronisme que serviria pels periferics que s'incorporin

  if (minutoMemory != minute())
  {
    ActualizaMinuto();   // Rutina per canvi automatic estiu/hivern
    registroSincronia(); // Enviem un registre de sincronisme tambe cada minut
  }

  //----------------------------------
  // Inici process iteratiu pricipal del Modul de 'Control y Proceso'
  // Iniciem el Polling als arduinos periferics

  // Sensores instalados  Nº  Tractament
  // ------------------- ---  ----------
  // Clima (t,h,ic)  = 1 (1)  Polling
  // Aigua           = 2 (1)  Polling
  // Infrarojos      = 3 (1)  Interrupció
  // Ultrasons       = 4 (1)  Interrupció
  // Moviment        = 5 (1)  Interrupció
  // TallCorrent     = 6 (1)  Polling
  //-------------------------------------------------

  inicio = millis(); // DEBUG per calibrar el temps de polling cuan sigui tot  montat

  esperaTimeOut = 100; // debug FIJO

  // Demanar dades Clima sensor DTH11
  iniciar_MIS_DATOS();
  MIS_DATOS.dato.sensor = 1;
  MIS_DATOS.dato.serie  = 1;
  // esperaTimeOut = 4000;          // Aquest sensor es molt lent
  if (emitirMensaje())
    if (leerRespuesta())
      verSiAlarma();                // Veure si tenim peticio d'alarma

  // bloque DEBUG -----------------------------------
  esperado = ( millis() - inicio);
  total = total + esperado;
  //Serial.print(F("esperado del Polling Clima = ")); Serial.println(esperado);
  //-------------------------------------------------

  //delay(500);

  inicio = millis(); // DEBUG per calibrar el temps de polling cuan sigui tot  montat

  // Demanar dades d'aigua sensor FC-37
  iniciar_MIS_DATOS();
  MIS_DATOS.dato.sensor = 2;
  MIS_DATOS.dato.serie  = 1;
  // esperaTimeOut = 2000;             // començem per 2000
  if (emitirMensaje())
    if (leerRespuesta())
      verSiAlarma();                   // Veure si tenim peticio d'alarma


  // bloque DEBUG -----------------------------------
  esperado = ( millis() - inicio);
  total = total + esperado;
  //Serial.print(F("esperado del Polling Aigua = ")); Serial.println(esperado);
  //-------------------------------------------------

  //delay(500); // DEBUG
  //-------------------------------------------------
  // ELs sensors 3,4 i 5 (IR, US, i PIR tenen rutinas d'interrupcio)
  // per la qual cosa emeten directament un missatge al bloc de comunicacións
  //-------------------------------------------------

  inicio = millis(); // DEBUG per calibrar el temps de polling cuan sigui tot  montat

  // Demanar dades tallCorrent Transformador + alimentador adaptat al efecte
  iniciar_MIS_DATOS();
  MIS_DATOS.dato.sensor = 6;
  MIS_DATOS.dato.serie  = 1;
  // esperaTimeOut = 2000;             // començem per 2000
  if (emitirMensaje())
    if (leerRespuesta())
      verSiAlarma();                   // Veure si tenim peticio d'alarma


  // bloque DEBUG -----------------------------------
  esperado = ( millis() - inicio);
  total = total + esperado;
  //Serial.print(F("esperado del Polling Volts = ")); Serial.println(esperado);
  //-------------------------------------------------

  //delay(500);

  // Esperem 1/2 s. i repetim
  //delay(500);
  //----------------------------------
  // bloque DEBUG
  esperado = ( millis() - inicio);
  //Serial.print(F("esperado total del Polling sin delays = ")); Serial.println(esperado);
  //delay (2000);                   // DEBUG
}

//---------------------------------------------------------------------

void registroSincronia()
{
  // S'envia el registre sense llegir resposta.
  iniciar_MIS_DATOS();      // Neteixem l'area del missatge
  MIS_DATOS.dato.sensor = 0;
  MIS_DATOS.dato.serie  = 0;
  MIS_DATOS.dato.epoch  = now(); // Informem el temps UNIX
  emitirMensaje();          // El registro de sincronismo no espera respuesta
}

//---------------------------------------------------------------------

bool emitirMensaje()
{
  // Responde al mensaje recibido cambiando cap y cua y ++ el resto
  bool result = false;
  bool ok = false;
  radio.stopListening();       // Cambio de escucha a emision
  //delay(30);
  while (!ok)
  {
    for (int i = 0 ; i < 6 ; i++)                    // Reintentamos 5 veces
    {
      ok = radio.write( &MIS_DATOS, sizeof(DATOS) ); // Enviamos el mensaje
      //-------------------------------------------------------------------
      // si a la quinta iteracion no es ok
      // Ponemos "ok" a capón porque la librería NRF24L01 no funciona bien
      if (!ok)
        if (i > 4) ok = true;
    }
    //-------------------------------------------------------------------
  }
  if (ok)
  {
    result = true;
    //Serial.println(F("ok..."));                             // DEBUG
    //Serial.println(F("Mensaje enviado -----------"));       // DEBUG
    //print_MIS_DATOS();                                      // DEBUG
  }
  else
  {
    result = false;
    //Serial.println(F("NO ok..."));                           // DEBUG
    //Serial.println(F("NO Mensaje enviado --------"));        // DEBUG
  }
  // Cambio de emision a escucha
  radio.startListening();
  return result;
}

//------------------------------------------------------------------

bool leerRespuesta()
{
  // Esperamos hasta tener una respuesta o un TimeOut (esperaTimeOut)
  // Hemos de esperar el tiempo que haga falta y luego lo mediremos

  bool result = false;
  // Esperamos hasta tener una respuesta o un TimeOut
  unsigned long tiempoTimeOut = millis();
  bool timeout = false;

  while ( ! radio.available() && ! timeout )
    if (millis() - tiempoTimeOut > esperaTimeOut) timeout = true;

  // Ahora, tenemos datos para leer o TimeOut

  if (timeout) // No tenemos datos para leer recuperar. TimeOut
  {
    result = false;
    //Serial.println(F("Lectura TimeOut -----------------------------"));
  }
  else
  {
    // descargamos bloques hasta el final del mensaje
    // a destacar que el mensaje que manejamos es de 27 bytes
    // y tenemos radio.setPayloadSize(32)
    // Es decir que el mensaje cabe en un solo bloque

    bool done = false;
    while (!done)
      done = radio.read( &TUS_DATOS, sizeof(DATOS) );
    // -----------------------------------------------------DEBUG
    //Serial.println(F("Mensaje leido------------------------------"));
    //Serial.print(F("cap = "));
    //Serial.println(TUS_DATOS.dato.cap);
    //Serial.print(F("cua = "));
    //Serial.println(TUS_DATOS.dato.cua);
    // Vemos si se ha recibido integramente
    if (TUS_DATOS.dato.cap == 234 && TUS_DATOS.dato.cua == 123)
    {
      result = true;
      //Serial.println(F("Mensaje recibido integramente ---------------"));
      //print_TUS_DATOS();
    }
    else
    {
      result = false;
      //Serial.println(F("Lectura fallida. Mensaje Incompleto ---------"));
      //print_TUS_DATOS();
    }
  }
  return result;
}
//---------------------------------------------------------------------

void verSiAlarma()  // Veure si hi ha hagut alarmes
{
  if (!TUS_DATOS.dato.alarma == 0)
  {
    // Copiar TUS:DATOS a MIS_DATOS
    for (int i = 0 ; i < sizeof(DATOS) ; i++) MIS_DATOS.b[i] = TUS_DATOS.b[i];

    // Generem un missatge "111" per tal de demanar un SMS AL servidor GSM/GPRS
    MIS_DATOS.dato.cap = 123;
    MIS_DATOS.dato.cua = 234;
    MIS_DATOS.dato.interrupcio = 111;    // Alarma procedente de "Polling"
    emitirMensaje();                     // No te resposta

    Serial.println(F("ok... respuesta a"));              // DEBUG
    print_MIS_DATOS();
    Serial.println(F("Mensaje alarma recibido  ---------------"));
    print_TUS_DATOS();
  }
}
//---------------------------------------------------------------------

void iniciar_MIS_DATOS()
{
  // Initzializacio de camps per transmitir als sensors
  MIS_DATOS.dato.cap           = 123; // Senyal d'inici del misatge
  MIS_DATOS.dato.sensor        = 0;
  MIS_DATOS.dato.serie         = 0;
  MIS_DATOS.dato.valor1        = 0;
  MIS_DATOS.dato.valor2        = 0;
  MIS_DATOS.dato.valor3        = 0;
  MIS_DATOS.dato.valor4        = 0;
  MIS_DATOS.dato.valor5        = 0;
  MIS_DATOS.dato.alarma        = 0;
  MIS_DATOS.dato.interrupcio   = 0;
  MIS_DATOS.dato.epoch         = now();
  MIS_DATOS.dato.periferic     = periferic;
  MIS_DATOS.dato.menuActivo    = menuActivo;
  MIS_DATOS.dato.submenuActivo = submenuActivo;
  MIS_DATOS.dato.reservado1    = 0;
  MIS_DATOS.dato.reservado2    = 0;
  MIS_DATOS.dato.cua           = 234; // Senyal fi del misatge
}

//---------------------------------------------------------------------

void ponerEnHora() {
  if (RTC.read(tm)) { // Existe reloj RTC y esta activo
    sincronizarArduino(); // Ponemos la hora tambien en reloj Arduino
    relojActivo = "RTC";
  }
  else {
    if (RTC.chipPresent()) { // Existe reloj RTC pero inactivo
      // Tomar los datos del TimeStamp de compilacion
      if (getDate(__DATE__) && getTime(__TIME__)) {
        parse = true;
        // y configurar el RTC
        if (RTC.write(tm)) {
          config = true;
          relojActivo = "RTC";
          sincronizarArduino(); // Ponemos la hora lambien en reloj Arduino
        }
      }
    }
  }
  if (! (relojActivo == "RTC")) // Algo ha fallado.Ponemos en hora Arduino
    ponerEnHoraArduino();
}

//---------------------------------------------------------------------

void ponerEnHoraArduino()
{
  // Poner en hora a partir del timeStamp de compilacion
  bool parse = false;
  if (getDate(__DATE__) && getTime(__TIME__)) {
    parse = true;
    setTime(makeTime(tm));
    relojActivo = "Arduino";
    Serial.println(F("¡Hora Arduino Montada del TimeStamp. Se usara esta hora "));
    time_t t = now();
    printFecha(t);
  }
  else {
    relojActivo = "Ninguno";
    //Serial.println(F("¡Fallo al montar la Hora del TimeStamp. NO HAY HORA ACTIVA"));
  }
  //Serial.print(F("Reloj activo ")); Serial.println(relojActivo);
}

//---------------------------------------------------------------------

void sincronizarArduino() {
  setSyncProvider(RTC.get);      // Sincronizar el tiempo del Arduino con RTC
  if (timeStatus() != timeSet) { // No se ha conseguido la sincronia.
    //Serial.println(F("Error No se ha podido to sincronizar con el RTC"));
    //Serial.println(F("Pasar los ejemplos SetTime y ReadTest si existe RTC"));
  }
  else {
    //Serial.println(F("OK RTC y reloj Arduino sincronizados"));
    relojActivo = "Ambos";
  }
}

//---------------------------------------------------------------------

bool getDate(const char *str) { // Tomar fecha del TimeStamp de compilacion
  char Month[12];
  int Day, Year;
  uint8_t monthIndex;
  const char *monthName[12] = { // Necesario para descifrar el mes en el timestamp de compilacion
    "Jan", "Feb", "Mar", "Apr", "May", "Jun",
    "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
  };

  if (sscanf(str, "%s %d %d", Month, &Day, &Year) != 3) return false;
  for (monthIndex = 0; monthIndex < 12; monthIndex++) {
    if (strcmp(Month, monthName[monthIndex]) == 0) break;
  }
  if (monthIndex >= 12) return false;
  tm.Day = Day;
  tm.Month = monthIndex + 1;
  tm.Year = CalendarYrToTm(Year);
  return true;
}

//---------------------------------------------------------------------

bool getTime(const char *str) { // Tomar tiempo del TimeStamp de compilacion
  int Hour, Min, Sec;
  if (sscanf(str, "%d:%d:%d", &Hour, &Min, &Sec) != 3) return false;
  tm.Hour = Hour;
  tm.Minute = Min;
  tm.Second = Sec + 14; // ajustamos el desfase del tiempo de compilacion (mi PC=14seg)
  return true;
}

//---------------------------------------------------------------------

void ActualizaMinuto() {
  // Cambio automatico de hora Invierno<-->Verano
  // Trabajamos con el reloj de Arduino (Siempre presente)
  // Adelanta la hora. A partir del dia 25 de Marzo, busca el primer domingo
  // Tener en cuenta que Time.h da weekday=1 ==> Domingo
  // y cuando sean las 2 de la noche adelanta el reloj una hora

  if (month() == 3) { // Estamos en Marzo
    if (day() >= 25) { // Los ultimos 7 dias
      if ((weekday() == 1)) { // Y es domingo ==> Ultimo Domingo de Marzo
        if (hour() == 2) { // Son las 2 AM
          setTime(now() + 3600); // Adelantar una hora "A las 2 son las 3"
          if ((relojActivo == "RTC") || (relojActivo == "Ambos")) {
            // Vemos si existe el RTC
            RTC.set(now() + 3600);    // y si es asi lo ajustamos tambien
          }
        }
      }
    }
  }
  // Retrasa la hora. A partir del dia 25 de Octubre, busca el primer domingo
  // Tener en cuenta que Time.h da weekday=1 ==> Domingo
  // y cuando sean las 2 de la noche retrasa el reloj una hora
  if (month() == 10) { // Estamos en Octubre
    if (day() >= 25) { // Los ultimos 7 dias
      if (weekday() == 1) { // Y es domingo ==> Ultimo Domingo de Octubre
        if ((hour() == 2) && (horaRetrasada == false)) { // Son las 2 y aun no se ha retrasado la hora
          setTime(now() - 3600); // Atrasar una hora "A las 3 son las 2"
          horaRetrasada == true; // Marca el retraso como efectuado para evitar repetirlo
          if ((relojActivo == "RTC") || (relojActivo == "Ambos")) {
            // Vemos si existe el RTC
            RTC.set(now() - 3600); // y si es asi lo ajustamos tambien
          }
        }
      }
    }
  }
  // Si son ya las tres, desmarcamos el retraso (ponemos false)
  if (hour() == 3) { // Ya ha pasado la hora de espera
    horaRetrasada = false;
  }
  minutoMemory = minute(); // Actualiza minuto. ¡Hasta el proximo minuto!
}

//---------------------------------------------------------------------

void print_TUS_DATOS()
{
  time_t t = now();
  printFecha(t);
  Serial.print(F("cap             = ")); Serial.println(TUS_DATOS.dato.cap);
  Serial.print(F("sensor          = ")); Serial.println(TUS_DATOS.dato.sensor);
  Serial.print(F("serie           = ")); Serial.println(TUS_DATOS.dato.serie);
  Serial.print(F("valor sensor 1  = ")); Serial.println(TUS_DATOS.dato.valor1);
  Serial.print(F("valor sensor 2  = ")); Serial.println(TUS_DATOS.dato.valor2);
  Serial.print(F("valor sensor 3  = ")); Serial.println(TUS_DATOS.dato.valor3);
  Serial.print(F("valor sensor 4  = ")); Serial.println(TUS_DATOS.dato.valor4);
  Serial.print(F("valor sensor 5  = ")); Serial.println(TUS_DATOS.dato.valor5);
  Serial.print(F("alarma          = ")); Serial.println(TUS_DATOS.dato.alarma);
  Serial.print(F("interrupcio     = ")); Serial.println(TUS_DATOS.dato.interrupcio);
  Serial.print(F("epoch           = ")); Serial.println(TUS_DATOS.dato.epoch);
  Serial.print(F("periferic       = ")); Serial.println(TUS_DATOS.dato.periferic);
  Serial.print(F("menuActivo      = ")); Serial.println(TUS_DATOS.dato.menuActivo);
  Serial.print(F("submenuActivo   = ")); Serial.println(TUS_DATOS.dato.submenuActivo);
  Serial.print(F("reservado1      = ")); Serial.println(TUS_DATOS.dato.reservado1);
  Serial.print(F("reservado2      = ")); Serial.println(TUS_DATOS.dato.reservado2);
  Serial.print(F("cua             = ")); Serial.println(TUS_DATOS.dato.cua);
  Serial.println(F("================================================="));
}

//---------------------------------------------------------------------

void print_MIS_DATOS()
{
  time_t t = now();
  printFecha(t);
  Serial.print(F("cap             = ")); Serial.println(MIS_DATOS.dato.cap);
  Serial.print(F("sensor          = ")); Serial.println(MIS_DATOS.dato.sensor);
  Serial.print(F("serie           = ")); Serial.println(MIS_DATOS.dato.serie);
  Serial.print(F("valor sensor 1  = ")); Serial.println(MIS_DATOS.dato.valor1);
  Serial.print(F("valor sensor 2  = ")); Serial.println(MIS_DATOS.dato.valor2);
  Serial.print(F("valor sensor 3  = ")); Serial.println(MIS_DATOS.dato.valor3);
  Serial.print(F("valor sensor 4  = ")); Serial.println(MIS_DATOS.dato.valor4);
  Serial.print(F("valor sensor 5  = ")); Serial.println(MIS_DATOS.dato.valor5);
  Serial.print(F("alarma          = ")); Serial.println(MIS_DATOS.dato.alarma);
  Serial.print(F("interrupcio     = ")); Serial.println(MIS_DATOS.dato.interrupcio);
  Serial.print(F("epoch           = ")); Serial.println(MIS_DATOS.dato.epoch);
  Serial.print(F("periferic       = ")); Serial.println(MIS_DATOS.dato.periferic);
  Serial.print(F("menuActivo      = ")); Serial.println(MIS_DATOS.dato.menuActivo);
  Serial.print(F("submenuActivo   = ")); Serial.println(MIS_DATOS.dato.submenuActivo);
  Serial.print(F("reservado1      = ")); Serial.println(MIS_DATOS.dato.reservado1);
  Serial.print(F("reservado2      = ")); Serial.println(MIS_DATOS.dato.reservado2);
  Serial.print(F("cua             = ")); Serial.println(MIS_DATOS.dato.cua);
  Serial.println(F("================================================="));
}

//---------------------------------------------------------------------

void printFecha(time_t  t) // DEBUG
{
  Serial.print(F("Fecha y Hora (D/M/A H;M;S) -->  "));
  Serial.print(day(t)) ;    Serial.print(+ "/") ;   Serial.print(month(t));   Serial.print(+ "/") ;
  Serial.print(year(t));    Serial.print( " ") ;
  Serial.print(hour(t));   Serial.print(+ ":") ;   Serial.print(minute(t));   Serial.print(F(":")) ;
  Serial.println(second(t));
  //delay(500);
}

